/* random walk simulation */ 
#include <stdio.h>
#include <stdlib.h>
 
#define NumberIter  10      /* number of walks */
#define NumberSteps 10*100  /* number of steps per walk */
#define pi 3.14159265358979

FILE *output;

main()
{
  int i,j;
  double x, y, random_angle;
  double xsum[NumberSteps+1],ysum[NumberSteps+1], rsum[NumberSteps+1];
  
  output= fopen ("walk.out", "w");
  srand( (unsigned)time( NULL ) );
  for (i=0; i<=NumberSteps; i++) 
    { 
      rsum[i]=0; xsum[i]=0; ysum[i]=0; 
    }
  
  for (j=1; j<=NumberIter; j++)         /* average over walks */
    {
      x=0; y=0;                         /* start walk */      
      for (i=1;i<=NumberSteps; i++)
        {
          random_angle = 2*pi*(double)rand()/(double)RAND_MAX;
          x += sin(random_angle);
          y += cos(random_angle);

          xsum[i] += x;
          ysum[i] += y;
          rsum[i] += x*x+y*y;
        }
    }
  /* write results into file */
  for (i=0; i<=NumberSteps/100; i++) 
    {
      fprintf(output,"%i\t%f\t%f\t%f\n", i*100,
              rsum[i*100]/(double)NumberIter,
              xsum[i*100]/(double)NumberIter,  
              ysum[i*100]/(double)NumberIter );
    }
  
  fclose (output);
}
